/*
reinhard@finalmedia.de
Mi 29. Mär 09:08:25 CEST 2023

# intrange column min max

clone stdin to stdout
but inspect given column number (column separator is space character)
and omit line, if column value is a negative integer, no integer
or out of specified range.

needs exact 3 arguments:
1. column number
2. minimal value
3. maximal value

silently terminates on less arguments.

example Usage:

intrange 2 88 99

*/

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <limits.h>

int main(int argc, char* argv[])
{
    FILE *fp;
    char *line = NULL;
    size_t len = 0;
    int read;
    size_t i = 0;
    unsigned int j = 0;
    int col = 0;
    int currentcol = 0;
    int currentpos = 0;
    int min = 0;
    int max = 0;
    int value = 0;
    int showline = 1;
    char separator = ' ';

    if (argc<4) return 1;

    col = atoi(argv[1]);
    min = atoi(argv[2]);
    max = atoi(argv[3]);

    if (max<min) return 1;

 while (1) {

    fp = fopen("/dev/stdin", "r");
    if (fp == NULL) return 1;
    while ((read = getline(&line, &len, fp)) != -1)
    {

	currentcol=1;
	currentpos=0;
	showline=1;
	// search for separator character in current line
	for (i=0;i<strlen(line);i++)
	{

		if (line[i] == separator) { currentcol++; currentpos=i; }

		if (currentcol == col && showline > 0)	{ 	// only inspect choosen column


				value=0;		// initial value, since we will only allow positive integers
				i=strlen(line)-1;	// IMPORTANT: if column position found once in current line, no need for further search

				// abort, if ending space
				if ((size_t)(currentpos+1) > strlen(line)) break;

				// if negative number, than skip line
				if (line[currentpos+1]=='-') showline=0;

				// converting string to positive number via loop
				for (j=currentpos+1;j>0 && line[j]>47 && line[j]<58 && value<(INT_MAX-19) && showline>0;j++) {
					if (value>INT_MAX || value<0) { value=0; showline=0; }
					else { value = value * 10 + (line[j]-48); }

				}


				// hide line if not in range
				if (showline>0) {
					if (value<min || value>max) {
					showline=0;
					}
				}
		}
	}

	// else always print line
	if (showline>0) { printf("%s",line); fflush(stdout); }

	// reset values before next scan
	line='\0';
	value=0;

    }

    free(line);
    fclose(fp);
    return 0;

}
}

